// ignore_for_file: use_build_context_synchronously
import 'dart:convert';
import 'package:flutter/material.dart';
import 'package:file_picker/file_picker.dart';
import 'package:image_picker/image_picker.dart';
import 'package:provider/provider.dart';
import '../Forma_viewModel/Forma_view_model_screen.dart';
import '../../../../utils/image_constant.dart';
import '../../../../utils/size_utils.dart';
import '../../../../theme/app_style.dart';
import '../../../../widgets/app_bar/appbar_image.dart';
import '../../../../widgets/app_bar/appbar_title.dart';
import '../../../../widgets/app_bar/custom_app_bar.dart';
import '../../../../widgets/custom_button.dart';
import '../../../../widgets/custom_text_form_field.dart'; 
import '../../../../widgets/custom_dropdown_field.dart';
import 'dart:math';
import 'package:qr_flutter/qr_flutter.dart';
import 'package:barcode_widget/barcode_widget.dart';
import 'package:flutter_barcode_scanner/flutter_barcode_scanner.dart';
import 'package:intl/intl.dart';
 
import 'package:autocomplete_textfield/autocomplete_textfield.dart';
import 'package:http/http.dart' as http;
import 'package:flutter/services.dart';
import 'package:image_picker/image_picker.dart';
import 'package:fluttertoast/fluttertoast.dart';
import '../../../../Reuseable/reusable_date_picker_field.dart';
import '../../../../Reuseable/reusable_date_time_picker_field.dart'
;import 'package:multi_select_flutter/multi_select_flutter.dart';
import 'package:just_audio/just_audio.dart';
import 'package:video_player/video_player.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:lottie/lottie.dart';
import 'dart:io';
import '../../../../Reuseable/reusable_text_field.dart';
class formaCreateEntityScreen extends StatefulWidget {
  const formaCreateEntityScreen({super.key});

  @override
  _formaCreateEntityScreenState createState() => _formaCreateEntityScreenState();
}

class _formaCreateEntityScreenState extends State<formaCreateEntityScreen> {

final Map<String, dynamic> formData = {};
  final _formKey = GlobalKey<FormState>();
  final TextEditingController text_fieldController = TextEditingController();


  final TextEditingController number_fieldController = TextEditingController();


  final TextEditingController phone_numberController = TextEditingController();


  final TextEditingController paragraph_fieldController = TextEditingController();



  bool _passwordVisiblepassword_field = false;
  bool _isPasswordValidpassword_field = true;
  bool _doPasswordsMatchpassword_field = true;

  String _passwordpassword_field = ''; // To store the first password

  void _validatePasswordpassword_field(String password) {
    setState(() {
      _isPasswordValidpassword_field = password.isNotEmpty;
      _passwordpassword_field = password; // Store the password for later comparison
      _doPasswordsMatchpassword_field = true; // Reset match flag on new input
    });
  }

  void _validateConfirmPasswordpassword_field(String confirmPassword) {
    setState(() {
      _doPasswordsMatchpassword_field = confirmPassword == _passwordpassword_field;
    });
  }

  final TextEditingController textareaController = TextEditingController();


TextEditingController date_field = TextEditingController(); 

 DateTime selectedDatedate_field = DateTime.now();
  Future<void> _selectDatedate_field(BuildContext context) async {
    final DateTime? picked = await showDatePicker(
      context: context,
      initialDate: selectedDatedate_field,
      firstDate: DateTime(2000),
      lastDate: DateTime(2101),
    );
    if (picked != null && picked != selectedDatedate_field) {
      setState(() {
        selectedDatedate_field = picked;
      });
    }
  }


TextEditingController datetime_field = TextEditingController();

DateTime selectedDateTimedatetime_field = DateTime.now();
  Future<void> _selectDateTimedatetime_field(BuildContext context) async {
    final DateTime? picked = await showDatePicker(
      context: context,
      initialDate: selectedDateTimedatetime_field,
      firstDate: DateTime(2000),
      lastDate: DateTime(2101),
    );

    if (picked != null) {
      final TimeOfDay? pickedTime = await showTimePicker(
        context: context,
        initialTime: TimeOfDay.fromDateTime(selectedDateTimedatetime_field),
      );
      print(pickedTime);
      if (pickedTime != null) {
        setState(() {
          selectedDateTimedatetime_field = DateTime(
            picked.year,
            picked.month,
            picked.day,
            pickedTime.hour,
            pickedTime.minute,
          );
        });
      }
    }
  }


  bool _isemail_fieldEmailValid = true;
  void _validateemail_fieldEmail(String email) {
    setState(() {
      _isemail_fieldEmailValid = RegExp(r'^[\w-]+(\.[\w-]+)*@[\w-]+(\.[\w-]+)+$').hasMatch(email);
    });
  }


bool _isSwitchedtoggle_switch = false;
bool toggle_switch = false;

void _toggleSwitchtoggle_switch(bool value) {
  setState(() {
    _isSwitchedtoggle_switch = value;
  });
}

  bool _isUrlValidurl_field = true;
  void _validateUrlurl_field(String url) {
    setState(() {
      _isUrlValidurl_field = Uri.parse(url).isAbsolute;
    });
  }


 @override
  void initState() {
    super.initState(); 






















} 

  

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: CustomAppBar(
          height: getVerticalSize(49),
          leadingWidth: 40,
          leading: AppbarImage(
              height: getSize(24),
              width: getSize(24),
              svgPath: ImageConstant.imgArrowleftBlueGray900,
              margin: getMargin(left: 16, top: 12, bottom: 13),
              onTap: () {
                Navigator.pop(context);
              }),
          centerTitle: true,
          title: AppbarTitle(text: "Create Forma"),





















),
      body:Consumer<FormaViewModelScreen>(
            builder: (context, value, child) {
          return SingleChildScrollView(
        child: Padding(
          padding: const EdgeInsets.all(16),
          child: Form(
            key: _formKey,
            child: Column(
              children: [
 ReusableTextField(
                  controller: text_fieldController,

  onSaved:(value) => formData['text_field'] = value ,
  label:"Enter Text Field",
  // ValidationProperties
),

  SizedBox(height: 16),


ReusableTextField(
                  controller: number_fieldController,

              onSaved:(value) => formData['number_field'] = value ,
              label: "Enter Number Field",
              keyboardType: TextInputType.number,
              inputFormatters: [
                FilteringTextInputFormatter.allow((RegExp(r'[0-9]'))),
              ],
             // ValidationProperties     
),

SizedBox(height: 16), 

ReusableTextField(
              onSaved:(value) => formData['phone_number'] = value ,
              label: "Enter Phone Number",
              keyboardType: TextInputType.number,
              inputFormatters: [
              FilteringTextInputFormatter.digitsOnly,
LengthLimitingTextInputFormatter(
                        10), // Limit input to 10 digits
            ],
              validator: (value) {
                if (value == null || value.isEmpty) {
                  return 'Please enter Phone Number';
                }
                if (value.length != 10) {
                      return 'Phone number must be exactly 10 digits';
                    }
                    return null;
              },
            ),

ReusableTextField(
                  controller: paragraph_fieldController,

              onSaved:(value) => formData['paragraph_field'] = value ,
              label: "Enter Paragraph Field",
              maxLines: 5,

            ),

TextFormField(
                  obscureText: !_passwordVisiblepassword_field,
                  decoration: InputDecoration(
                    labelText: 'Password Field',
                    suffixIcon: IconButton(
                      icon: Icon(
                        _passwordVisiblepassword_field
                            ? Icons.visibility
                            : Icons.visibility_off,
                      ),
                      onPressed: () {
                        setState(() {
                          _passwordVisiblepassword_field = !_passwordVisiblepassword_field;
                        });
                      },
                    ),
                    errorText:
                        _isPasswordValidpassword_field ? null : 'Please enter a password',
                    border: OutlineInputBorder(),
                  ),
                  onSaved: (value) => formData['password_field'] = value,
                  onChanged: _validatePasswordpassword_field,
                ),
                const SizedBox(height: 16),
                TextFormField(
                  obscureText: !_passwordVisiblepassword_field,
                  decoration: InputDecoration(
                    labelText: 'Confirm Password Field',
                    suffixIcon: IconButton(
                      icon: Icon(
                        _passwordVisiblepassword_field
                            ? Icons.visibility
                            : Icons.visibility_off,
                      ),
                      onPressed: () {
                        setState(() {
                          _passwordVisiblepassword_field = !_passwordVisiblepassword_field;
                        });
                      },
                    ),
                    errorText:
                        _doPasswordsMatchpassword_field ? null : 'Passwords do not match',
                    border: OutlineInputBorder(),
                  ),
                  onChanged: _validateConfirmPasswordpassword_field,
                ),

ReusableTextField(
                  controller: textareaController,

  onSaved:(value) => formData['textarea'] = value ,
  label: "Enter Textarea",
  maxLines: 5,
// ValidationProperties
),


                       SizedBox(height: 16),


ReusableDatePickerField(
                label:' Date Field', controller: date_field 
,
                                      onSaved: (value) => formData['date_field'] = value,),
const SizedBox(height: 16),


ReusableDateTimePickerField(label: 'Datetime Field', controller: datetime_field,
                                      onSaved: (value) => formData['datetime_field'] = value,

),
const SizedBox(height: 16),



Padding(
                    padding: getPadding(top: 19),
                    child: Column(
                        crossAxisAlignment: CrossAxisAlignment.start,
                        mainAxisAlignment: MainAxisAlignment.start,
                        children: [
                          Text("Email Field",
                              overflow: TextOverflow.ellipsis,
                              textAlign: TextAlign.left,
                              style: AppStyle.txtGilroyMedium16Bluegray900),
                          CustomTextFormField(
                              hintText: "Enter Email Field",
    errorText: _isemail_fieldEmailValid ? null : 'Please enter a valid email',

onsaved: (value) => formData['email_field'] = value,
  onChanged: (value) {
    _validateemail_fieldEmail(value);
  },                            
  margin: getMargin(top: 6))
                        ])),

 Switch(
              value: _isSwitchedtoggle_switch,
              onChanged: _toggleSwitchtoggle_switch,
              activeColor: Colors.white,
              activeTrackColor: Colors.green,
              inactiveThumbColor: Colors.white,
              inactiveTrackColor: Colors.red,
            ),


Padding(
                    padding: getPadding(top: 19),
                    child: Column(
                        crossAxisAlignment: CrossAxisAlignment.start,
                        mainAxisAlignment: MainAxisAlignment.start,
                        children: [
                          Text("Url Field",
                              overflow: TextOverflow.ellipsis,
                              textAlign: TextAlign.left,
                              style: AppStyle.txtGilroyMedium16Bluegray900),
                          CustomTextFormField(
                              hintText: "Enter Url Field",
    errorText: _isUrlValidurl_field ? null : 'Please enter a valid URL',
  keyboardType: TextInputType.url,


                              onsaved: (value) => formData['url_field'] = value,
  onChanged: _validateUrlurl_field,

                              margin: getMargin(top: 6))
                        ])),
SizedBox(height: 16),

   const SizedBox(width: 8),
                CustomButton(
                  height: getVerticalSize(50),
                  text: "Submit",
                  margin: getMargin(top: 24, bottom: 5),
                  onTap: () async {
                    if (_formKey.currentState!.validate()) {
                      _formKey.currentState!.save(); 


















formData['toggle_switch'] = toggle_switch;




 
                      try {
                        print(formData);
  Map<String, dynamic> createdEntity =  await value.createEntity(formData); 






















 

                        Navigator.pop(context);
                      } catch (e) {
                        // ignore: use_build_context_synchronously
                        showDialog(
                          context: context,
                          builder: (BuildContext context) {
                            return AlertDialog(
                              title: const Text('Error'),
                              content: Text('Failed to create Forma: $e'),
                              actions: [
                                TextButton(
                                  child: const Text('OK'),
                                  onPressed: () {
                                    Navigator.of(context).pop();
                                  },
                                ),
                              ],
                            );
                          },
                        );
                      }
                    }
                  },
                ),






















   ],
          ),
              ),
            ),
          );
        }));
  }
}